/*
 * File:   Open4D
 * Author: Fabiola Pacheco
 * 
 * Created on 08/22/2016
 * Last modification on 10/11/2016
 */

#include <iostream>
#include <string>
#include <QString>

#include <itkImage.h>
#include <itkImageFileWriter.h>
#include <itkImageFileReader.h>

using namespace std;

class Open4D
{

public:
   
  ///Constructor of the class
  static Open4D *New()
  {
    return new Open4D;
  } 

  /*
  set volume filename
  */
  void SetFilename(QString);

  /*
  read the volume data
  */
  void Update();

  /*
  reaturn the itk volume
  */
  itk::Image<unsigned char, 4>::Pointer GetOutput();

private:

  /*
  volumefilename
  */
  QString filename;

  /*
  format of the volume
  */
  std::string format;

  /*
  machine mnufacturer
  */
  std::string manufacturer;

  /*
  patient ID
  */
  std::string patientID;

  /*
  patient name
  */
  std::string patientName;

  /*
  institute name
  */
  std::string instituteName;

  /*
  General electric ms
  */
  std::string gems;

  /*
  X size
  */
  int x;

  /*
  Y size
  */
  int y;

  /*
  Z size
  */
  int z;

  /*
  Voxel size
  */
  double voxSize;

  /*
  Time secuensy
  */
  int tSecuensy;

  /*
  Size of one volume
  */
  int volSize;

  /*
  Size of Volume Complete
  */
  int volComSize;
  /*
  The output itk volume
  */
  itk::Image<unsigned char, 4>::Pointer vol4d;
};