//
//  OnMouseMovePtr.h
//  US_Probe_Calibration
//
//  Created by Zian Fanti on 07/12/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
#ifndef US_Probe_Calibration_OnMouseMovePtr_h
#define US_Probe_Calibration_OnMouseMovePtr_h

#include <vtkCommand.h>
#include <vtkPropPicker.h>
#include <vtkCornerAnnotation.h>
#include <vtkSmartPointer.h>
#include <vtkImageViewer2.h>

//!Interaction with mouse
/*!
  The mouse motion callback, to pick the image and recover pixel values
*/
template<class Widget>
class QVTKImageWidgetCommand : public vtkCommand
{
public:

  typedef Widget WidgetType;

  static QVTKImageWidgetCommand *New()
  {
        return new QVTKImageWidgetCommand;
  }
  
  vtkTypeMacro(QVTKImageWidgetCommand, vtkCommand);

  QVTKImageWidgetCommand();

  ~QVTKImageWidgetCommand();

  void SetPicker(vtkSmartPointer<vtkPropPicker> picker);

  void SetImageWidget(WidgetType* widget);
  
  void SetImageViewer(vtkSmartPointer<vtkImageViewer2>);

  /**
   Point 2D position in widget
   */
  void Execute(vtkObject *, unsigned long vtkNotUsed(event), void *);
  

private:

  /** Pointer to the picker */
  vtkSmartPointer<vtkPropPicker> Picker;

  /** The widget related to the mouse events */
  WidgetType* ImageWidget;

  vtkSmartPointer<vtkImageViewer2> Viewer;
  
};

#ifndef VTK_MANUAL_INSTANTIATION
#include "QVTKImageWidgetCommand.cpp"
#endif

#endif